GF2NP Class Reference

GF(2^n) with Polynomial Basis. More...

`#include <gf2n.h>`

Inheritance diagram for GF2NP:

## Public Member Functions

| GF2NP (const PolynomialMod2 &modulus)
virtual GF2NP * | Clone () const
virtual void | DEREncode (BufferedTransformation &bt) const
void | DEREncodeElement (BufferedTransformation &out, const Element &a) const
void | BERDecodeElement (BufferedTransformation &in, Element &a) const
bool | Equal (const Element &a, const Element &b) const
bool | IsUnit (const Element &a) const
unsigned int | MaxElementBitLength () const
unsigned int | MaxElementByteLength () const
Element | SquareRoot (const Element &a) const
Element | HalfTrace (const Element &a) const
Element | SolveQuadraticEquation (const Element &a) const
Public Member Functions inherited from QuotientRing< EuclideanDomainOf< PolynomialMod2 > >
| QuotientRing (const EuclideanDomain &domain, const Element &modulus)
const EuclideanDomain & | GetDomain () const
const Element & | GetModulus () const
bool | Equal (const Element &a, const Element &b) const
const Element & | Identity () const
| Provides the Identity element.
const Element & | Add (const Element &a, const Element &b) const
Element & | Accumulate (Element &a, const Element &b) const
const Element & | Inverse (const Element &a) const
const Element & | Subtract (const Element &a, const Element &b) const
Element & | Reduce (Element &a, const Element &b) const
const Element & | Double (const Element &a) const
bool | IsUnit (const Element &a) const
const Element & | MultiplicativeIdentity () const
| Retrieves the multiplicative identity.
const Element & | Multiply (const Element &a, const Element &b) const
const Element & | Square (const Element &a) const
const Element & | MultiplicativeInverse (const Element &a) const
bool | operator== (const QuotientRing< EuclideanDomainOf< PolynomialMod2 > > &rhs) const
Public Member Functions inherited from AbstractRing< T::Element >
| AbstractRing ()
| Construct an AbstractRing.
| AbstractRing (const AbstractRing &source)
| Copy construct an AbstractRing.
AbstractRing & | operator= (const AbstractRing &source)
| Assign an AbstractRing.
virtual bool | IsUnit (const Element &a) const=0
| Determines whether an element is a unit in the group.
virtual const Element & | Multiply (const Element &a, const Element &b) const=0
| Multiplies elements in the group.
virtual const Element & | MultiplicativeInverse (const Element &a) const=0
| Calculate the multiplicative inverse of an element in the group.
virtual const Element & | Square (const Element &a) const
| Square an element in the group.
virtual const Element & | Divide (const Element &a, const Element &b) const
| Divides elements in the group.
virtual Element | Exponentiate (const Element &a, const Integer &e) const
| Raises a base to an exponent in the group.
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO.
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Exponentiates a base to multiple exponents in the Ring.
virtual const AbstractGroup< T > & | MultiplicativeGroup () const
| Retrieves the multiplicative group.
Public Member Functions inherited from AbstractGroup< T >
virtual bool | Equal (const Element &a, const Element &b) const =0
| Compare two elements for equality.
virtual const Element & | Add (const Element &a, const Element &b) const =0
| Adds elements in the group.
virtual const Element & | Inverse (const Element &a) const =0
| Inverts the element in the group.
virtual bool | InversionIsFast () const
| Determine if inversion is fast.
virtual const Element & | Double (const Element &a) const
| Doubles an element in the group.
virtual const Element & | Subtract (const Element &a, const Element &b) const
| Subtracts elements in the group.
virtual Element & | Accumulate (Element &a, const Element &b) const
| TODO.
virtual Element & | Reduce (Element &a, const Element &b) const
| Reduces an element in the congruence class.
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
| Performs a scalar multiplication.
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO.
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Multiplies a base to multiple exponents in a group.

## Additional Inherited Members

Public Types inherited from QuotientRing< EuclideanDomainOf< PolynomialMod2 > >
typedef EuclideanDomainOf< PolynomialMod2 > | EuclideanDomain
typedef T::Element | Element
Public Types inherited from AbstractRing< T::Element >
typedef T | Element
Public Types inherited from AbstractGroup< T >
typedef T | Element

## Detailed Description

GF(2^n) with Polynomial Basis.

Definition at line 298 of file gf2n.h.

## Member Function Documentation

## Clone()

virtual GF2NP * GF2NP::Clone | ( |  | ) | const

inline virtual

Definition at line 303 of file gf2n.h.

## DEREncode()

virtual void GF2NP::DEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual

Definition at line 304 of file gf2n.h.

## Equal()

bool GF2NP::Equal | ( | const Element & | a,
|  | const Element & | b
| ) |  | const

inline

Definition at line 310 of file gf2n.h.

## IsUnit()

bool GF2NP::IsUnit | ( | const Element & | a | ) | const

inline

Definition at line 313 of file gf2n.h.

## MaxElementBitLength()

unsigned int GF2NP::MaxElementBitLength | ( |  | ) | const

inline

Definition at line 316 of file gf2n.h.

## MaxElementByteLength()

unsigned int GF2NP::MaxElementByteLength | ( |  | ) | const

inline

Definition at line 319 of file gf2n.h.

The documentation for this class was generated from the following file:

- gf2n.h